/*
 * This file is part of Alida, a Java library for 
 * Automatic Logging of Process Information in Data Analysis.
 *
 * Copyright (C) 2010 - 2011
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/*
 * Most recent change(s):
 *
 * $Rev: 3732 $
 * $Date: 2011-04-28 17:49:16 +0200 (Do, 28 Apr 2011) $
 * $Author: moeller $
 *
 */

package de.unihalle.informatik.Alida.demo;

import de.unihalle.informatik.Alida.exceptions.ALDOperatorException;
import de.unihalle.informatik.Alida.operator.ALDOperator;
import de.unihalle.informatik.Alida.operator.Parameter;

/**
 * Operator class to demonstrate data creation.
 * 
 * @author moeller
 */
public class ALDDataMakeOp extends ALDOperator {

  /**
   * Generated array with double values.
   */
  @Parameter( label= "Generated data", 
  		type = Parameter.Type.OUTPUT, description = "Generated data.")
  private Double [] data;

  /**
   * Constructor.
   * @throws ALDOperatorException
   */
  protected ALDDataMakeOp() throws ALDOperatorException {
		super();
	}

	/**
	 * Returns the generated data array.
	 */
	public Double [] getData() {
		return this.data;
	}

	@Override
	protected void operate() {
			this.data = new Double[]{new Double(1.0), new Double(2.0),
					new Double(3.0), new Double(4.0), new Double(5.0)};
	}
}
