/*
 * This file is part of Alida, a Java library for 
 * Automatic Logging of Process Information in Data Analysis.
 *
 * Copyright (C) 2010 - 2011
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/* 
 * Most recent change(s):
 * 
 * $Rev: 3749 $
 * $Date: 2011-05-02 14:50:15 +0200 (Mo, 02 Mai 2011) $
 * $Author: posch $
 * 
 */
package de.unihalle.informatik.Alida.operator;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.annotation.Documented;

/**
 * Annotate the role/type of Arguments of Operators.
 * Use Parameter instead.
 * @author Stefan posch
 *
 * @deprecated
 */

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
@Documented
@Deprecated
public @interface ALDArgumentAnnotation {
	/**
	 * @deprecated
     */

	enum ALDArgumentType { INPUT, OUTPUT, PARAMETER, SUPPLEMENTAL };

    /**
     * @return  type of this argument
     */
    ALDArgumentType type() default ALDArgumentType.PARAMETER;   
    
    /**
     * @return  explanation
     */
    String description() default "";   
    
}
