/*
 * This file is part of Alida, a Java library for 
 * Automatic Logging of Process Information in Data Analysis.
 *
 * Copyright (C) 2010 - 2011
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Fore more information on Alida, visit
 *
 *    http://www.informatik.uni-halle.de/alida/
 *
 */

/* 
 * Most recent change(s):
 * 
 * $Rev: 3749 $
 * $Date: 2011-05-02 14:50:15 +0200 (Mo, 02 Mai 2011) $
 * $Author: posch $
 * 
 */

package de.unihalle.informatik.Alida.operator;

import java.lang.reflect.Field;

/** This class describes the arguments which may be used as inputs, parameters,
 *  outputs, or supplemental arguments for operators.
 *  The descriptions contains a name, the java class, and explanatory string,
 *  a boolean indicating if this argument is requeired or optional, and a default value.
 *  The latter two make oly sense for inputs and parameters and are currently
 *  unused for supplemental arguments.
 *  The fild is used for internal means.
 *  Note: default values are valid only for the (old) implementation without
 *  annotations an will disapear in th enear future.
 *
 * @deprecated 
 */

@Deprecated
public class ALDOpArgumentDescriptor {
	public final String name;
	public final Class myclass;
	public final String explanation;
	public final boolean required;
	public final Object defaultValue;
    Field field;

	/* Construct a descriptor 
	 *
	 * @param	name	name of argument
	 * @param	myclass	java class 
	 * @param	explanation explanatory string
	 * @param	required	is this argument required for the operator
	 * @param	Object default value
	 */
	public ALDOpArgumentDescriptor( String name, Class myclass, String explanation,
			boolean required, Object defaultValue) {
		this.name = name;
		this.myclass = myclass;
		this.explanation = explanation;
		this.required = required;
		this.defaultValue = defaultValue;
		this.field = null;
	}

	/* Construct a descriptor 
	 *
	 * @param	name	name of argument
	 * @param	myclass	java class 
	 * @param	explanation explanatory string
	 * @param	required	is this argument required for the operator
	 * @param	default value
	 * @param	field the field for this member
	 */
	public ALDOpArgumentDescriptor( String name, Class myclass, String explanation,
			boolean required, Object defaultValue, Field field) {
		this.name = name;
		this.myclass = myclass;
		this.explanation = explanation;
		this.required = required;
		this.defaultValue = defaultValue;
		this.field = field;
	}

	/* Print this descriptor to standard out
	 */
	public void print() {
		System.out.println( name + " of type " + myclass.toString() + 
		(required ? " is reqired (" : " is optional (") +
		"exlanation: " + explanation + ")," + " default: " + 
		(defaultValue != null ? defaultValue.toString() : "null") +
        ", field: " + field);
		
	}
}
